<?php
if( !function_exists( 'iconv' ) ){
  echo '<h2><center>CONVERTER WILL NOT WORK.<br />Library ICONV in PHP is required!!!</center></h2>';
  exit;
}
/*
* READ FIRST howTo.txt FILE!!!
* Converter tested on: PHP 5.2.0, Apache 2.2.3
*/
$sDirFrom = 'db_old/'; // here put all files from Quick.Cart 2.x version
$sDirTo   = 'db/'; // create this directory and give chmod 777
$sLang    = 'ja'; // write language of Your old site ex: en, pl, ru, nl etc.
$sIso     = 'euc-jp'; // write what ISO that You use on Your, for polish default is ISO-8859-2, for english, deutch etc is ISO-8859-1

$sIso = strtoupper( $sIso );
// convert *_categories.php and *_categories_ext.php and *_categories_files.php
if( is_file( $sDirFrom.$sLang.'_categories_ext.php' ) && is_file( $sDirFrom.$sLang.'_categories.php' ) && is_file( $sDirFrom.$sLang.'_categories_files.php' ) ){
  // *_categories_ext.php
  // before - 0 iCategory, 1 sDescriptionShort, 2 sDescriptionFull
  // after - 0 iPage, 1 sDescriptionFull, 2 sMetaDescription, 3 sMetaKeywords, 4 sTemplate, 5 sTheme, 6 sUrl, 7 sBanner
  $aFile = file( $sDirFrom.$sLang.'_categories_ext.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_pages_ext.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );

  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aData[4] ) )
      $aData[4] = trim( $aData[4] );
    else
      $aData[4] = null;

    fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[2].'$$$$$$$'."\n" ) );
    $aPagesDescription[$aData[0]] = $aData[1];
  } // end for
  fclose( $rFile );

  // *_categories.php
  // before - 0 iCategory, 1 sName, 2 iParent, 3 iStatus, 4 iType, 5 iPosition, 6 iProducts
  // now - 0 iPage, 1 iPageParent, 2 sName, 3 sNameTitle, 4 sDescriptionShort, 5 iStatus, 6 iPosition, 7 iType, 8 iSubpagesShow, 9 iProducts
  $aFile = file( $sDirFrom.$sLang.'_categories.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_pages.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aPagesDescription[$aData[0]] ) ){
      if( $aData[4] == 1 )
        $aData[4] = 3;
      elseif( $aData[4] == 3 )
        $aData[4] = 1;
      fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[2].'$'.$aData[1].'$$'.$aPagesDescription[$aData[0]].'$'.$aData[3].'$'.$aData[5].'$'.$aData[4].'$1$'.$aData[6].'$'."\n" ) );
    }
    else{
      echo 'ERROR - no page ext data in "'.$sDirFrom.$sLang.'_categories_ext.php" with id <b>'.$aData[0].'</b><br />';
    }
  } // end for
  fclose( $rFile );

  // *_categories_files.php
  // before - 0 iFile, 1 iLink, 2 sFileName, 3 sDescription, 4 iType, 5 iPosition
  // before - 0 iFile, 1 iPage, 2 sFileName, 3 sDescription, 4 iType -> iPhoto, 5 iPosition, 6 iType, 7 iSize1, 8 iSize2
  $aFile = file( $sDirFrom.$sLang.'_categories_files.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_pages_files.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aPagesDescription[$aData[1]] ) ){
      if( isset( $aData[5] ) )
        $aData[5] = trim( $aData[5] );
      else
        $aData[5] = null;

      $iType = 2;

      fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[1].'$'.$aData[2].'$'.$aData[3].'$'.$aData[4].'$'.$aData[5].'$'.$iType.'$$$'."\n" ) );
    }
  } // end for
  fclose( $rFile );
  echo '<h2><center>CATEGORIES/PAGES - DONE</center></h2>';
}
else{
  echo '<h2><center>ERROR</center></h2>';
  echo 'There is no file <b>'.$sDirFrom.$sLang.'_categories.php</b> or <b>'.$sDirFrom.$sLang.'_categories_ext.php</b> or <b>'.$sDirFrom.$sLang.'_categories_files.php</b> ';
}

// convert *_products.php and *_products_categories.php and *_products_ext.php and *_products_files.php
if( is_file( $sDirFrom.$sLang.'_products.php' ) && is_file( $sDirFrom.$sLang.'_products_categories.php' ) && is_file( $sDirFrom.$sLang.'_products_ext.php' ) && is_file( $sDirFrom.$sLang.'_products_files.php' ) ){
  // *_products_ext.php
  // before - 0 iProduct, 1 sDescriptionFull
  // after - 0 iProduct, 1 sNameTitle, 2 sTemplate, 3 sTheme, 4 sMetaKeywords, 5 sMetaDescription, 6 sDescriptionFull
  $aFile = file( $sDirFrom.$sLang.'_products_ext.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_products_ext.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$$$$$$'.$aData[1].'$'."\n" ) );
    $aProductsDescription[$aData[0]] = $aData[1];
  } // end for
  fclose( $rFile );

  // *_products.php
  // before - 0 iProduct, 1 sName, 2 fPrice, 3 sDescriptionShort, 4 iStatus, 5 iPosition
  // now - 'iProduct' => 0, 'sName' => 1, 'fPrice' => 2, 'iStatus' => 3, 'iPosition' => 4, 'sAvailable' => 5, 'sDescriptionShort' => 6
  $aFile = file( $sDirFrom.$sLang.'_products.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_products.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aProductsDescription[$aData[0]] ) ){
      if( $aData[4] == 1 )
        $aData[4] = 3;
      elseif( $aData[4] == 3 )
        $aData[4] = 1;
      fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[1].'$'.$aData[2].'$'.$aData[4].'$'.$aData[5].'$$'.$aData[3].'$'."\n" ) );
    }
    else{
      echo 'ERROR - no products ext data in "'.$sDirFrom.$sLang.'_products_ext.php" with id <b>'.$aData[0].'</b><br />';
    }
  } // end for
  fclose( $rFile );

  // *_products_categories.php
  // before - 0 iCategory, 1 iProduct
  // now - 'iProduct' => 0, 'iPage' => 1
  $aFile = file( $sDirFrom.$sLang.'_products_categories.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_products_pages.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aProductsDescription[$aData[1]] ) ){
      fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[1].'$'.$aData[0].'$'."\n" ) );
    }
    else{
      echo 'ERROR - no products ext data in "'.$sDirFrom.$sLang.'_products_ext.php" with id <b>'.$aData[0].'</b><br />';
    }
  } // end for
  fclose( $rFile );

  // *_products_files.php
  // before - 0 iFile, 1 iLink, 2 sFileName, 3 sDescription, 4 iType, 5 iPosition
  // before - 0 iFile, 1 iProduct, 2 sFileName, 3 sDescription, 4 iType -> iPhoto, 5 iPosition, 6 iType, 7 iSize1, 8 iSize2
  $aFile = file( $sDirFrom.$sLang.'_products_files.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_products_files.php', 'w' );

  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aProductsDescription[$aData[1]] ) ){
      if( isset( $aData[5] ) )
        $aData[5] = trim( $aData[5] );
      else
        $aData[5] = null;

      $iType = 2;

      fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[1].'$'.$aData[2].'$'.$aData[3].'$'.$aData[4].'$'.$aData[5].'$'.$iType.'$$$'."\n" ) );
    }
  } // end for
  fclose( $rFile );
  echo '<h2><center>PRODUCTS - DONE</center></h2>';
}
else{
  echo '<h2><center>ERROR</center></h2>';
  echo 'There is no file <b>'.$sDirFrom.$sLang.'_products.php</b> or <b>'.$sDirFrom.$sLang.'_products_ext.php</b> or <b>'.$sDirFrom.$sLang.'_products_files.php</b> or <b>'.$sDirFrom.$sLang.'_products_categories.php</b>';
}

// convert *_couriers.php
if( is_file( $sDirFrom.$sLang.'_couriers.php' ) ){
  // *_couriers.php
  // before - 0 iCourier, 1 sName, 2 fPrice
  // after - 'iCarrier' => 0, 'sName' => 1, 'fPrice' => 2
  $aFile = file( $sDirFrom.$sLang.'_couriers.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.$sLang.'_carriers.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[1].'$'.$aData[2].'$'."\n" ) );
  } // end for
  fclose( $rFile );
  echo '<h2><center>CARRIERS - DONE</center></h2>';

  $rFile = fopen( $sDirTo.$sLang.'_carriers_payments.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  fclose( $rFile );

  $rFile = fopen( $sDirTo.$sLang.'_payments.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  fclose( $rFile );
}
else{
  echo '<h2><center>ERROR</center></h2>';
  echo 'There is no file <b>'.$sDirFrom.$sLang.'_couriers.php</b>';
}

// convert orders.php and orders_ext.php and orders_products.php
if( is_file( $sDirFrom.'orders.php' ) && is_file( $sDirFrom.'orders_ext.php' ) && is_file( $sDirFrom.'orders_products.php' ) ){
  $rFile = fopen( $sDirTo.'orders_temp.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  fclose( $rFile );

  // orders.php
  // before - 0 iOrder, 1 sLang, 2 iStatus
  $aFile = file( $sDirFrom.'orders.php' );
  $iCount= count( $aFile );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( $aData[2] > 0 ){
      $aOrders[$aData[0]] = $aData;
    }
  } // end for

  // orders_ext.php
  // before - 0 iOrder, 1 iTime, 2 iCourier, 3 sCourier, 4 fCourierPrice, 5 sFirstName, 6 sLastName, 7 sCompanyName, 8 sStreet, 9 sZipCode, 10 sCity, 11 sTelephone, 12 sEmail, 13 sIp, 14 sComment
  // after - 'iOrder' => 0, 'sLanguage' => 1, 'iStatus' => 2, 'iTime' => 3, 'iCarrier' => 4, 'iPayment' => 5, 'sCarrierName' => 6, 'fCarrierPrice' => 7, 'sPaymentName' => 8, 'sPaymentPrice' => 9, 'sFirstName' => 10, 'sLastName' => 11, 'sCompanyName' => 12, 'sStreet' => 13, 'sZipCode' => 14, 'sCity' => 15, 'sPhone' => 16, 'sEmail' => 17, 'sIp' => 18
  $aFile = file( $sDirFrom.'orders_ext.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.'orders.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  
  $rFile2 = fopen( $sDirTo.'orders_comments.php', 'w' );
  fwrite( $rFile2, '<?php exit; ?>'."\n" );

  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( !isset( $aOrders[$aData[0]] ) ){
      $aOrders[$aData[0]][1] = $sLang;
      $aOrders[$aData[0]][2] = 1;
    }

    fwrite( $rFile, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aOrders[$aData[0]][1].'$'.$aOrders[$aData[0]][2].'$'.$aData[1].'$'.$aData[2].'$$'.$aData[3].'$'.$aData[4].'$$$'.$aData[5].'$'.$aData[6].'$'.$aData[7].'$'.$aData[8].'$'.$aData[9].'$'.$aData[10].'$'.$aData[11].'$'.$aData[12].'$'.$aData[13].'$'."\n" ) );
    fwrite( $rFile2, iconv( $sIso, 'UTF-8', $aData[0].'$'.$aData[14].'$'."\n" ) );
    $aOrdersOk[$aData[0]] = true;
  } // end for
  fclose( $rFile );
  fclose( $rFile2 );

  // orders_products.php
  // before - 0 iElement, 1 iOrder, 2 iProduct, 3 iQuantity, 4 fPrice, 5 sProduct
  // after - 'iElement' => 0, 'iOrder' => 1, 'iProduct' => 2, 'iQuantity' => 3, 'fPrice' => 4, 'sName' => 5
  $aFile = file( $sDirFrom.'orders_products.php' );
  $iCount= count( $aFile );
  $rFile = fopen( $sDirTo.'orders_products.php', 'w' );
  $iElement = 1;
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  for( $i = 1; $i < $iCount; $i++ ){
    $aData = explode( '$', $aFile[$i] );
    if( isset( $aOrdersOk[$aData[1]] ) ){
      fwrite( $rFile, iconv( $sIso, 'UTF-8', $iElement.'$'.$aData[1].'$'.$aData[2].'$'.$aData[3].'$'.$aData[4].'$'.$aData[5].'$'."\n" ) );
      $iElement++;
    }
  } // end for
  fclose( $rFile );

  $rFile = fopen( $sDirTo.'orders_status.php', 'w' );
  fwrite( $rFile, '<?php exit; ?>'."\n" );
  fclose( $rFile );

  echo '<h2><center>ORDERS - DONE</center></h2>';

}
else{
  echo '<h2><center>ERROR</center></h2>';
  echo 'There is no file <b>'.$sDirFrom.'orders.php</b> or <b>'.$sDirFrom.'orders_ext.php</b> or <b>'.$sDirFrom.'orders_products.php</b> ';
}
?>